#include <iostream>
#include <fstream>
#include <math.h>
#include <iomanip>

using namespace std;
using pfun = double (*)(double); // ukazatel na funkci

void tabulka(pfun f, ostream& kam, double a, double b, int kolik, const char* jmeno)
{
    double krok = (b - a) / (kolik - 1);
    kam << "Tabulka funkce " << jmeno << endl;
    kam << " x    |      f(x)" << endl;
    kam << "------+------------" << endl;
    double x = a;
    kam << setprecision(2) << showpoint << fixed; // nastavení manipulátorů pro "kam"
    for (int i = 0; i < kolik; i++)
    {
        kam << setw(5) << x << " | " << setw(9) << f(x) << endl;
        x += krok;
    }
}

double parabola(double x)
{
    return 2 * x * x - x - 1;
}

int main()
{
    ofstream vystup("tabulka_parabola.txt"); // vytvoření proudu (jen výstup)
    tabulka(parabola, vystup, -2, 2, 20, "parabola");
    vystup.close(); // uzavření proudu

    vystup.open("tabulka_sinus.txt"); // otevření proudu pro jiný soubor
    tabulka(sin, vystup, 0, 3.14159265358, 20, "sinus");
    vystup.close();

    cout << "Vytvoreny dva soubory." << endl;
}