#include <iostream>
#include <fstream>

using namespace std;

int main()
{   // práce s binárním souborem pomocí objektových proudů

    ofstream vystup("data.dat", ios::out | ios::binary); // proud jen pro výstup
    // 1) zápis
    for (int i = 1; i <= 10; i++)
        vystup.write((char*)&i, sizeof(int));
    vystup.close();

    // 2) čtení
    ifstream vstup("data.dat", ios::in | ios::binary); // proud jen pro vstup
    cout << "Obsah bin. souboru:" << endl;
    while (vstup.good())
    {
        int i; // obsahem binárního souboru jsou INTy
        if (vstup.read((char*)&i, sizeof(int))) // lze přečíst?
            cout << i << endl;
    }
    vstup.close();

    // 3) aktualizace čísla na uživatelem zadané pozici
    int pozice, hodnota;
    cout << "Zadejte pozici, kterou chcete zmenit: ";
    cin >> pozice;
    cout << "Zadejte novou hodnotu: ";
    cin >> hodnota;

    fstream zmena("data.dat", ios::in | ios::out | ios::binary); // proud pro vstup i výstup
    // zjistíme velikost souboru - posuneme se na konec (seekg/get nebo seekp/put)
    zmena.seekg(0, zmena.end);   // posuň se o kolik (0), odkud (zmena.end)
    int delkaSouboru = zmena.tellg(); // velikost v bajtech
    cout << "Velikost souboru je: " << delkaSouboru << endl;
    // zjistíme počet prvků:  velikost / typ dat
    int celkemPrvku = delkaSouboru / sizeof(int);
    cout << "Pocet prvku v souboru je: " << celkemPrvku << endl;
    if (pozice < 0 || pozice >= celkemPrvku)
        cout << "Nelze aktualizovat (chybna pozice)!" << endl;
    else
    {
        zmena.seekg(0, zmena.beg); // posun na začátek
        zmena.seekg(pozice * sizeof(int), zmena.beg); // posun na požadovanou pozici
        zmena.write((char*)&hodnota, sizeof(int)); // změna dat (zápis nového čísla)
        zmena.close(); // uzavření proudu

        // 4) ověření, že aktualizace proběhla => čtení ze souboru
        vstup.open("data.dat", ios::in | ios::binary);
        cout << "Po aktualizaci:" << endl;
        while (vstup.good())
        {
            int i;
            if (vstup.read((char*)&i, sizeof(int))) // lze přečíst číslo?
                cout << i << endl;
        }
    }
    return 0; // návratová hodnota od main()
}
